' This class is "generated" and will be overwritten.
' Your customizations should be made in SectionRecord.vb

Imports System.Data.SqlTypes
Imports System.Data
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider
Imports Persons.Data

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="SectionTable"></see> class.
''' Provides access to the schema information and record data of a database table or view named Section.
''' </summary>
''' <remarks>
''' The connection details (name, location, etc.) of the database and table (or view) accessed by this class 
''' are resolved at runtime based on the connection string in the application's Web.Config file.
''' <para>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, use 
''' <see cref="SectionTable.Instance">SectionTable.Instance</see>.
''' </para>
''' </remarks>
''' <seealso cref="SectionTable"></seealso>

<Serializable()> Public Class BaseSectionTable
    Inherits PrimaryKeyTable
    

    Private ReadOnly TableDefinitionString As String = SectionDefinition.GetXMLString()







    Protected Sub New()
        MyBase.New()
        Me.Initialize()
    End Sub

    Protected Overridable Sub Initialize()
        Dim def As New XmlTableDefinition(TableDefinitionString)
        Me.TableDefinition = New TableDefinition()
        Me.TableDefinition.TableClassName = System.Reflection.Assembly.CreateQualifiedName("App_Code", "Persons.Business.SectionTable")
        def.InitializeTableDefinition(Me.TableDefinition)
        Me.ConnectionName = def.GetConnectionName()
        Me.RecordClassName = System.Reflection.Assembly.CreateQualifiedName("App_Code", "Persons.Business.SectionRecord")
        Me.ApplicationName = "App_Code"
        Me.DataAdapter = New SectionSqlTable()
        Directcast(Me.DataAdapter, SectionSqlTable).ConnectionName = Me.ConnectionName
        
        Me.TableDefinition.AdapterMetaData = Me.DataAdapter.AdapterMetaData
        SectionIdColumn.CodeName = "SectionId"
        SectionNameColumn.CodeName = "SectionName"
        SectionAbbvrNameColumn.CodeName = "SectionAbbvrName"
        SectionENameColumn.CodeName = "SectionEName"
        MarshallFullColumn.CodeName = "MarshallFull"
        MarShallColumn.CodeName = "MarShall"
        GeneralFullColumn.CodeName = "GeneralFull"
        GeneralColumn.CodeName = "General"
        LtGeneralFullColumn.CodeName = "LtGeneralFull"
        LtGeneralColumn.CodeName = "LtGeneral"
        MjGeneralFullColumn.CodeName = "MjGeneralFull"
        MjGeneralColumn.CodeName = "MjGeneral"
        SpColonelFullColumn.CodeName = "SpColonelFull"
        SpColonelColumn.CodeName = "SpColonel"
        ColonelFullColumn.CodeName = "ColonelFull"
        ColonelColumn.CodeName = "Colonel"
        LtColonelFullColumn.CodeName = "LtColonelFull"
        LtColonelColumn.CodeName = "LtColonel"
        MajorFullColumn.CodeName = "MajorFull"
        MajorColumn.CodeName = "Major"
        CaptianFullColumn.CodeName = "CaptianFull"
        CaptianColumn.CodeName = "Captian"
        LieutenantFullColumn.CodeName = "LieutenantFull"
        LieutenantColumn.CodeName = "Lieutenant"
        SubLieutenantFullColumn.CodeName = "SubLieutenantFull"
        SubLieutenantColumn.CodeName = "SubLieutenant"
        Sm0FullColumn.CodeName = "Sm0Full"
        Sm0Column.CodeName = "Sm0"
        Sm1FullColumn.CodeName = "Sm1Full"
        Sm1Column.CodeName = "Sm1"
        Sm2FullColumn.CodeName = "Sm2Full"
        Sm2Column.CodeName = "Sm2"
        Sm3FullColumn.CodeName = "Sm3Full"
        Sm3Column.CodeName = "Sm3"
        SgtFullColumn.CodeName = "SgtFull"
        SgtColumn.CodeName = "Sgt"
        CptFullColumn.CodeName = "CptFull"
        CptColumn.CodeName = "Cpt"
        PtcFullColumn.CodeName = "PtcFull"
        PtcColumn.CodeName = "Ptc"
        PvtVolFullColumn.CodeName = "PvtVolFull"
        PvtVolColumn.CodeName = "PvtVol"
        Sm4FullColumn.CodeName = "Sm4Full"
        Sm4Column.CodeName = "Sm4"
        PvtFullColumn.CodeName = "PvtFull"
        PvtColumn.CodeName = "Pvt"
        Sm4NowColumn.CodeName = "Sm4Now"
        PvtstColumn.CodeName = "Pvtst"
        PvtndColumn.CodeName = "Pvtnd"
        EmpFullColumn.CodeName = "EmpFull"
        EmpColumn.CodeName = "Emp"
        EmpOffFullColumn.CodeName = "EmpOffFull"
        EmpOffColumn.CodeName = "EmpOff"
        EmpTmpFullColumn.CodeName = "EmpTmpFull"
        EmpTmpColumn.CodeName = "EmpTmp"
        
    End Sub

#Region "Overriden methods"

    
#End Region

#Region "Properties for columns"

    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SectionId column object.
    ''' </summary>
    Public ReadOnly Property SectionIdColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(0), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SectionId column object.
    ''' </summary>
    Public Shared ReadOnly Property SectionId() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.SectionIdColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SectionName column object.
    ''' </summary>
    Public ReadOnly Property SectionNameColumn() As BaseClasses.Data.StringColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(1), BaseClasses.Data.StringColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SectionName column object.
    ''' </summary>
    Public Shared ReadOnly Property SectionName() As BaseClasses.Data.StringColumn
        Get
            Return SectionTable.Instance.SectionNameColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SectionAbbvrName column object.
    ''' </summary>
    Public ReadOnly Property SectionAbbvrNameColumn() As BaseClasses.Data.StringColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(2), BaseClasses.Data.StringColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SectionAbbvrName column object.
    ''' </summary>
    Public Shared ReadOnly Property SectionAbbvrName() As BaseClasses.Data.StringColumn
        Get
            Return SectionTable.Instance.SectionAbbvrNameColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SectionEName column object.
    ''' </summary>
    Public ReadOnly Property SectionENameColumn() As BaseClasses.Data.StringColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(3), BaseClasses.Data.StringColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SectionEName column object.
    ''' </summary>
    Public Shared ReadOnly Property SectionEName() As BaseClasses.Data.StringColumn
        Get
            Return SectionTable.Instance.SectionENameColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MarshallFull column object.
    ''' </summary>
    Public ReadOnly Property MarshallFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(4), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MarshallFull column object.
    ''' </summary>
    Public Shared ReadOnly Property MarshallFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.MarshallFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MarShall column object.
    ''' </summary>
    Public ReadOnly Property MarShallColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(5), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MarShall column object.
    ''' </summary>
    Public Shared ReadOnly Property MarShall() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.MarShallColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.GeneralFull column object.
    ''' </summary>
    Public ReadOnly Property GeneralFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(6), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.GeneralFull column object.
    ''' </summary>
    Public Shared ReadOnly Property GeneralFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.GeneralFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.General column object.
    ''' </summary>
    Public ReadOnly Property GeneralColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(7), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.General column object.
    ''' </summary>
    Public Shared ReadOnly Property General() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.GeneralColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LtGeneralFull column object.
    ''' </summary>
    Public ReadOnly Property LtGeneralFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(8), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LtGeneralFull column object.
    ''' </summary>
    Public Shared ReadOnly Property LtGeneralFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.LtGeneralFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LtGeneral column object.
    ''' </summary>
    Public ReadOnly Property LtGeneralColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(9), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LtGeneral column object.
    ''' </summary>
    Public Shared ReadOnly Property LtGeneral() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.LtGeneralColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MjGeneralFull column object.
    ''' </summary>
    Public ReadOnly Property MjGeneralFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(10), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MjGeneralFull column object.
    ''' </summary>
    Public Shared ReadOnly Property MjGeneralFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.MjGeneralFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MjGeneral column object.
    ''' </summary>
    Public ReadOnly Property MjGeneralColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(11), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MjGeneral column object.
    ''' </summary>
    Public Shared ReadOnly Property MjGeneral() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.MjGeneralColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SpColonelFull column object.
    ''' </summary>
    Public ReadOnly Property SpColonelFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(12), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SpColonelFull column object.
    ''' </summary>
    Public Shared ReadOnly Property SpColonelFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.SpColonelFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SpColonel column object.
    ''' </summary>
    Public ReadOnly Property SpColonelColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(13), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SpColonel column object.
    ''' </summary>
    Public Shared ReadOnly Property SpColonel() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.SpColonelColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.ColonelFull column object.
    ''' </summary>
    Public ReadOnly Property ColonelFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(14), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.ColonelFull column object.
    ''' </summary>
    Public Shared ReadOnly Property ColonelFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.ColonelFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Colonel column object.
    ''' </summary>
    Public ReadOnly Property ColonelColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(15), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Colonel column object.
    ''' </summary>
    Public Shared ReadOnly Property Colonel() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.ColonelColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LtColonelFull column object.
    ''' </summary>
    Public ReadOnly Property LtColonelFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(16), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LtColonelFull column object.
    ''' </summary>
    Public Shared ReadOnly Property LtColonelFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.LtColonelFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LtColonel column object.
    ''' </summary>
    Public ReadOnly Property LtColonelColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(17), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LtColonel column object.
    ''' </summary>
    Public Shared ReadOnly Property LtColonel() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.LtColonelColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MajorFull column object.
    ''' </summary>
    Public ReadOnly Property MajorFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(18), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.MajorFull column object.
    ''' </summary>
    Public Shared ReadOnly Property MajorFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.MajorFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Major column object.
    ''' </summary>
    Public ReadOnly Property MajorColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(19), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Major column object.
    ''' </summary>
    Public Shared ReadOnly Property Major() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.MajorColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.CaptianFull column object.
    ''' </summary>
    Public ReadOnly Property CaptianFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(20), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.CaptianFull column object.
    ''' </summary>
    Public Shared ReadOnly Property CaptianFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.CaptianFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Captian column object.
    ''' </summary>
    Public ReadOnly Property CaptianColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(21), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Captian column object.
    ''' </summary>
    Public Shared ReadOnly Property Captian() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.CaptianColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LieutenantFull column object.
    ''' </summary>
    Public ReadOnly Property LieutenantFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(22), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.LieutenantFull column object.
    ''' </summary>
    Public Shared ReadOnly Property LieutenantFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.LieutenantFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Lieutenant column object.
    ''' </summary>
    Public ReadOnly Property LieutenantColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(23), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Lieutenant column object.
    ''' </summary>
    Public Shared ReadOnly Property Lieutenant() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.LieutenantColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SubLieutenantFull column object.
    ''' </summary>
    Public ReadOnly Property SubLieutenantFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(24), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SubLieutenantFull column object.
    ''' </summary>
    Public Shared ReadOnly Property SubLieutenantFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.SubLieutenantFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SubLieutenant column object.
    ''' </summary>
    Public ReadOnly Property SubLieutenantColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(25), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SubLieutenant column object.
    ''' </summary>
    Public Shared ReadOnly Property SubLieutenant() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.SubLieutenantColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm0Full column object.
    ''' </summary>
    Public ReadOnly Property Sm0FullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(26), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm0Full column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm0Full() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm0FullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm0 column object.
    ''' </summary>
    Public ReadOnly Property Sm0Column() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(27), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm0 column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm0() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm0Column
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm1Full column object.
    ''' </summary>
    Public ReadOnly Property Sm1FullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(28), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm1Full column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm1Full() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm1FullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm1 column object.
    ''' </summary>
    Public ReadOnly Property Sm1Column() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(29), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm1 column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm1() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm1Column
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm2Full column object.
    ''' </summary>
    Public ReadOnly Property Sm2FullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(30), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm2Full column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm2Full() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm2FullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm2 column object.
    ''' </summary>
    Public ReadOnly Property Sm2Column() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(31), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm2 column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm2() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm2Column
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm3Full column object.
    ''' </summary>
    Public ReadOnly Property Sm3FullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(32), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm3Full column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm3Full() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm3FullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm3 column object.
    ''' </summary>
    Public ReadOnly Property Sm3Column() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(33), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm3 column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm3() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm3Column
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SgtFull column object.
    ''' </summary>
    Public ReadOnly Property SgtFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(34), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.SgtFull column object.
    ''' </summary>
    Public Shared ReadOnly Property SgtFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.SgtFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sgt column object.
    ''' </summary>
    Public ReadOnly Property SgtColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(35), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sgt column object.
    ''' </summary>
    Public Shared ReadOnly Property Sgt() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.SgtColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.CptFull column object.
    ''' </summary>
    Public ReadOnly Property CptFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(36), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.CptFull column object.
    ''' </summary>
    Public Shared ReadOnly Property CptFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.CptFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Cpt column object.
    ''' </summary>
    Public ReadOnly Property CptColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(37), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Cpt column object.
    ''' </summary>
    Public Shared ReadOnly Property Cpt() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.CptColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.PtcFull column object.
    ''' </summary>
    Public ReadOnly Property PtcFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(38), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.PtcFull column object.
    ''' </summary>
    Public Shared ReadOnly Property PtcFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.PtcFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Ptc column object.
    ''' </summary>
    Public ReadOnly Property PtcColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(39), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Ptc column object.
    ''' </summary>
    Public Shared ReadOnly Property Ptc() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.PtcColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.PvtVolFull column object.
    ''' </summary>
    Public ReadOnly Property PvtVolFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(40), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.PvtVolFull column object.
    ''' </summary>
    Public Shared ReadOnly Property PvtVolFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.PvtVolFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.PvtVol column object.
    ''' </summary>
    Public ReadOnly Property PvtVolColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(41), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.PvtVol column object.
    ''' </summary>
    Public Shared ReadOnly Property PvtVol() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.PvtVolColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm4Full column object.
    ''' </summary>
    Public ReadOnly Property Sm4FullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(42), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm4Full column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm4Full() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm4FullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm4 column object.
    ''' </summary>
    Public ReadOnly Property Sm4Column() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(43), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm4 column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm4() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm4Column
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.PvtFull column object.
    ''' </summary>
    Public ReadOnly Property PvtFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(44), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.PvtFull column object.
    ''' </summary>
    Public Shared ReadOnly Property PvtFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.PvtFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Pvt column object.
    ''' </summary>
    Public ReadOnly Property PvtColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(45), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Pvt column object.
    ''' </summary>
    Public Shared ReadOnly Property Pvt() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.PvtColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm4Now column object.
    ''' </summary>
    Public ReadOnly Property Sm4NowColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(46), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Sm4Now column object.
    ''' </summary>
    Public Shared ReadOnly Property Sm4Now() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.Sm4NowColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Pvtst column object.
    ''' </summary>
    Public ReadOnly Property PvtstColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(47), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Pvtst column object.
    ''' </summary>
    Public Shared ReadOnly Property Pvtst() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.PvtstColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Pvtnd column object.
    ''' </summary>
    Public ReadOnly Property PvtndColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(48), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Pvtnd column object.
    ''' </summary>
    Public Shared ReadOnly Property Pvtnd() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.PvtndColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpFull column object.
    ''' </summary>
    Public ReadOnly Property EmpFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(49), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpFull column object.
    ''' </summary>
    Public Shared ReadOnly Property EmpFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.EmpFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Emp column object.
    ''' </summary>
    Public ReadOnly Property EmpColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(50), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.Emp column object.
    ''' </summary>
    Public Shared ReadOnly Property Emp() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.EmpColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpOffFull column object.
    ''' </summary>
    Public ReadOnly Property EmpOffFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(51), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpOffFull column object.
    ''' </summary>
    Public Shared ReadOnly Property EmpOffFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.EmpOffFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpOff column object.
    ''' </summary>
    Public ReadOnly Property EmpOffColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(52), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpOff column object.
    ''' </summary>
    Public Shared ReadOnly Property EmpOff() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.EmpOffColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpTmpFull column object.
    ''' </summary>
    Public ReadOnly Property EmpTmpFullColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(53), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpTmpFull column object.
    ''' </summary>
    Public Shared ReadOnly Property EmpTmpFull() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.EmpTmpFullColumn
        End Get
    End Property
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpTmp column object.
    ''' </summary>
    Public ReadOnly Property EmpTmpColumn() As BaseClasses.Data.NumberColumn
        Get
            Return CType(Me.TableDefinition.ColumnList(54), BaseClasses.Data.NumberColumn)
        End Get
    End Property


    
    ''' <summary>
    ''' This is a convenience property that provides direct access to the table's Section_.EmpTmp column object.
    ''' </summary>
    Public Shared ReadOnly Property EmpTmp() As BaseClasses.Data.NumberColumn
        Get
            Return SectionTable.Instance.EmpTmpColumn
        End Get
    End Property


#End Region


#Region "Shared helper methods"

    ''' <summary>
    ''' This is a shared function that can be used to get an array of SectionRecord records using a where clause.
    ''' </summary>
    Public Shared Function GetRecords(ByVal where As String) As SectionRecord()

        Return GetRecords(where, Nothing, BaseTable.MIN_PAGE_NUMBER, BaseTable.MAX_BATCH_SIZE)
    End Function
    
    ''' <summary>
    ''' This is a shared function that can be used to get an array of SectionRecord records using a where clause.
    ''' </summary>
    Public Shared Function GetRecords(ByVal join As BaseFilter, ByVal where As String) As SectionRecord()

        Return GetRecords(join, where, Nothing, BaseTable.MIN_PAGE_NUMBER, BaseTable.MAX_BATCH_SIZE)
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get an array of SectionRecord records using a where and order by clause.
    ''' </summary>
    Public Shared Function GetRecords( _
     ByVal where As String, _
     ByVal orderBy As OrderBy) As SectionRecord()

        Return GetRecords(where, orderBy, BaseTable.MIN_PAGE_NUMBER, BaseTable.MAX_BATCH_SIZE)
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get an array of SectionRecord records using a where and order by clause.
    ''' </summary>
    Public Shared Function GetRecords( _
     ByVal join As BaseFilter, _
     ByVal where As String, _
     ByVal orderBy As OrderBy) As SectionRecord()

        Return GetRecords(join, where, orderBy, BaseTable.MIN_PAGE_NUMBER, BaseTable.MAX_BATCH_SIZE)
    End Function
    
    ''' <summary>
    ''' This is a shared function that can be used to get an array of SectionRecord records using a where and order by clause clause with pagination.
    ''' </summary>
    Public Shared Function GetRecords( _
     ByVal where As String, _
     ByVal orderBy As OrderBy, _
     ByVal pageIndex As Integer, _
     ByVal pageSize As Integer) As SectionRecord()
        
        Dim whereFilter As SqlFilter =  Nothing
        If Not where Is Nothing AndAlso where.trim() <> "" Then
            whereFilter =  New SqlFilter(where)
        End If
        Dim join As BaseClasses.Data.BaseFilter = Nothing 
        Dim recList As ArrayList =  SectionTable.Instance.GetRecordList(join, whereFilter, Nothing, orderBy, pageIndex, pageSize)
 
        Return CType(recList.ToArray(GetType(Persons.Business.SectionRecord)), SectionRecord())
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get an array of SectionRecord records using a where and order by clause clause with pagination.
    ''' </summary>
    Public Shared Function GetRecords( _
     ByVal join As BaseFilter, _
     ByVal where As String, _
     ByVal orderBy As OrderBy, _
     ByVal pageIndex As Integer, _
     ByVal pageSize As Integer) As SectionRecord()
        
        Dim whereFilter As SqlFilter =  Nothing
        If Not where Is Nothing AndAlso where.trim() <> "" Then
            whereFilter =  New SqlFilter(where)
        End If
         
        Dim recList As ArrayList =  SectionTable.Instance.GetRecordList(join, whereFilter, Nothing, orderBy, pageIndex, pageSize)
 
        Return CType(recList.ToArray(GetType(Persons.Business.SectionRecord)), SectionRecord())
    End Function

    Public Shared Function GetRecords( _
     ByVal where As WhereClause, _
     ByVal orderBy As OrderBy, _
     ByVal pageIndex As Integer, _
     ByVal pageSize As Integer) As SectionRecord()
        Dim join As BaseClasses.Data.BaseFilter = Nothing
        Dim recList As ArrayList = SectionTable.Instance.GetRecordList(join, where.GetFilter(), Nothing, orderBy, pageIndex, pageSize)

        Return CType(recList.ToArray(GetType(Persons.Business.SectionRecord)), SectionRecord())
    End Function

    Public Shared Function GetRecords( _
     ByVal join As BaseFilter, _
     ByVal where As WhereClause, _
     ByVal orderBy As OrderBy, _
     ByVal pageIndex As Integer, _
     ByVal pageSize As Integer) As SectionRecord()

        Dim recList As ArrayList = SectionTable.Instance.GetRecordList(join, where.GetFilter(), Nothing, orderBy, pageIndex, pageSize)

        Return CType(recList.ToArray(GetType(Persons.Business.SectionRecord)), SectionRecord())
    End Function

    Public Shared Function GetRecords( _
     ByVal where As WhereClause, _
     ByVal orderBy As OrderBy, _
     ByVal pageIndex As Integer, _
     ByVal pageSize As Integer, _
     ByRef totalRecords As Integer) As SectionRecord()
        Dim join As BaseClasses.Data.BaseFilter = Nothing
        Dim recList As ArrayList = SectionTable.Instance.GetRecordList(join, where.GetFilter(), Nothing, orderBy, pageIndex, pageSize, totalRecords)

        Return CType(recList.ToArray(GetType(Persons.Business.SectionRecord)), SectionRecord())
    End Function

    Public Shared Function GetRecords( _
     ByVal join As BaseFilter, _
     ByVal where As WhereClause, _
     ByVal orderBy As OrderBy, _
     ByVal pageIndex As Integer, _
     ByVal pageSize As Integer, _
     ByRef totalRecords As Integer) As SectionRecord()

        Dim recList As ArrayList = SectionTable.Instance.GetRecordList(join, where.GetFilter(), Nothing, orderBy, pageIndex, pageSize, totalRecords)

        Return CType(recList.ToArray(GetType(Persons.Business.SectionRecord)), SectionRecord())
    End Function
    
    ''' <summary>
    ''' This is a shared function that can be used to get total number of records that will be returned using the where clause.
    ''' </summary>
    Public Shared Function GetRecordCount(ByVal where As String) As Integer

        Dim whereFilter As SqlFilter = Nothing
        If Not where Is Nothing AndAlso where.Trim() <> "" Then
            whereFilter = New SqlFilter(where)
        End If

        Return CInt(SectionTable.Instance.GetRecordListCount(Nothing, whereFilter, Nothing, Nothing))
    End Function

''' <summary>
    ''' This is a shared function that can be used to get total number of records that will be returned using the where clause.
    ''' </summary>
    Public Shared Function GetRecordCount(ByVal join As BaseFilter, ByVal where As String) As Integer

        Dim whereFilter As SqlFilter = Nothing
        If Not where Is Nothing AndAlso where.Trim() <> "" Then
            whereFilter = New SqlFilter(where)
        End If

        Return CInt(SectionTable.Instance.GetRecordListCount(join, whereFilter, Nothing, Nothing))
    End Function

    Public Shared Function GetRecordCount(ByVal where As WhereClause) As Integer
        Return CInt(SectionTable.Instance.GetRecordListCount(Nothing, where.GetFilter(), Nothing, Nothing))
    End Function
    
      Public Shared Function GetRecordCount(ByVal join As BaseFilter, ByVal where As WhereClause) As Integer
        Return CInt(SectionTable.Instance.GetRecordListCount(join, where.GetFilter(), Nothing, Nothing))
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get a SectionRecord record using a where clause.
    ''' </summary>
    Public Shared Function GetRecord(ByVal where As String) As SectionRecord
        Dim orderBy As OrderBy = Nothing
        Return GetRecord(where, orderBy)
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get a SectionRecord record using a where clause.
    ''' </summary>
    Public Shared Function GetRecord(ByVal join As BaseFilter, ByVal where As String) As SectionRecord
        Dim orderBy As OrderBy = Nothing
        Return GetRecord(join, where, orderBy)
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get a SectionRecord record using a where and order by clause.
    ''' </summary>
    Public Shared Function GetRecord( _
     ByVal where As String, _
     ByVal orderBy As OrderBy) As SectionRecord

        Dim whereFilter As SqlFilter = Nothing
        If Not where Is Nothing AndAlso where.Trim() <> "" Then
            whereFilter = New SqlFilter(where)
        End If
        Dim join As BaseClasses.Data.BaseFilter = Nothing
        Dim recList As ArrayList = SectionTable.Instance.GetRecordList(join, whereFilter, Nothing, orderBy, BaseTable.MIN_PAGE_NUMBER, BaseTable.MIN_BATCH_SIZE)

        Dim rec As SectionRecord = Nothing
        If recList.Count > 0 Then
            rec = CType(recList(0), SectionRecord)
        End If

        Return rec
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get a SectionRecord record using a where and order by clause.
    ''' </summary>
    Public Shared Function GetRecord( _
     ByVal join As BaseFilter, _
     ByVal where As String, _
     ByVal orderBy As OrderBy) As SectionRecord

        Dim whereFilter As SqlFilter = Nothing
        If Not where Is Nothing AndAlso where.Trim() <> "" Then
            whereFilter = New SqlFilter(where)
        End If

        Dim recList As ArrayList = SectionTable.Instance.GetRecordList(join, whereFilter, Nothing, orderBy, BaseTable.MIN_PAGE_NUMBER, BaseTable.MIN_BATCH_SIZE)

        Dim rec As SectionRecord = Nothing
        If recList.Count > 0 Then
            rec = CType(recList(0), SectionRecord)
        End If

        Return rec
    End Function


    Public Shared Function GetValues( _
        ByVal col As BaseColumn, _
         ByVal where As WhereClause, _
         ByVal orderBy As OrderBy, _
         ByVal maxItems As Integer) As String()

        ' Create the filter list.
        Dim retCol As SqlBuilderColumnSelection = New SqlBuilderColumnSelection(False, True)
        retCol.AddColumn(col)

        Return SectionTable.Instance.GetColumnValues(retCol, Nothing, where.GetFilter(), Nothing, orderBy, BaseTable.MIN_PAGE_NUMBER, maxItems)

    End Function

    Public Shared Function GetValues( _
         ByVal col As BaseColumn, _
         ByVal join As BaseFilter, _
         ByVal where As WhereClause, _
         ByVal orderBy As OrderBy, _
         ByVal maxItems As Integer) As String()

        ' Create the filter list.
        Dim retCol As SqlBuilderColumnSelection = New SqlBuilderColumnSelection(False, True)
        retCol.AddColumn(col)

        Return SectionTable.Instance.GetColumnValues(retCol, join, where.GetFilter(), Nothing, orderBy, BaseTable.MIN_PAGE_NUMBER, maxItems)

    End Function


    ''' <summary>
    ''' This is a shared function that can be used to get a DataTable to bound with a data bound control using a where clause.
    ''' </summary>
    Public Shared Function GetDataTable(ByVal where As String) As System.Data.DataTable

        Dim recs() As SectionRecord = GetRecords(where)
        Return SectionTable.Instance.CreateDataTable(recs, Nothing)
    End Function
    
    ''' <summary>
    ''' This is a shared function that can be used to get a DataTable to bound with a data bound control using a where clause.
    ''' </summary>
    Public Shared Function GetDataTable(ByVal join As BaseFilter, ByVal where As String) As System.Data.DataTable

        Dim recs() As SectionRecord = GetRecords(join, where)
        Return SectionTable.Instance.CreateDataTable(recs, Nothing)
    End Function
    

    ''' <summary>
    ''' This is a shared function that can be used to get a DataTable to bound with a data bound control using a where and order by clause.
    ''' </summary>
    Public Shared Function GetDataTable(ByVal where As String, ByVal orderBy As OrderBy) As System.Data.DataTable

        Dim recs() As SectionRecord = GetRecords(where, orderBy)
        Return SectionTable.Instance.CreateDataTable(recs, Nothing)
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get a DataTable to bound with a data bound control using a where and order by clause.
    ''' </summary>
    Public Shared Function GetDataTable(ByVal join As BaseFilter, ByVal where As String, ByVal orderBy As OrderBy) As System.Data.DataTable

        Dim recs() As SectionRecord = GetRecords(join, where, orderBy)
        Return SectionTable.Instance.CreateDataTable(recs, Nothing)
    End Function


    ''' <summary>
    ''' This is a shared function that can be used to get a DataTable to bound with a data bound control using a where and order by clause with pagination.
    ''' </summary>
    Public Shared Function GetDataTable( _
     ByVal where As String, _
     ByVal orderBy As OrderBy, _
     ByVal pageIndex As Integer, _
     ByVal pageSize As Integer) As System.Data.DataTable

        Dim recs() As SectionRecord = GetRecords(where, orderBy, pageIndex, pageSize)
        Return SectionTable.Instance.CreateDataTable(recs, Nothing)
    End Function

    ''' <summary>
    ''' This is a shared function that can be used to get a DataTable to bound with a data bound control using a where and order by clause with pagination.
    ''' </summary>
    Public Shared Function GetDataTable( _
     ByVal join As BaseFilter, _    
     ByVal where As String, _
     ByVal orderBy As OrderBy, _
     ByVal pageIndex As Integer, _
     ByVal pageSize As Integer) As System.Data.DataTable

        Dim recs() As SectionRecord = GetRecords(join, where, orderBy, pageIndex, pageSize)
        Return SectionTable.Instance.CreateDataTable(recs, Nothing)
    End Function


    ''' <summary>
    ''' This is a shared function that can be used to delete records using a where clause.
    ''' </summary>
    Public Shared Sub DeleteRecords(ByVal where As String)
        If where = Nothing OrElse where.Trim() = "" Then
            Return
        End If

        Dim whereFilter As SqlFilter = New SqlFilter(where)
        SectionTable.Instance.DeleteRecordList(whereFilter)
    End Sub

    ''' <summary>
    ''' This is a shared function that can be used to export records using a where clause.
    ''' </summary>
    Public Shared Function Export(ByVal where As String) As String
        Dim whereFilter As SqlFilter = Nothing
        If Not where Is Nothing AndAlso where.Trim() <> "" Then
            whereFilter = New SqlFilter(where)
        End If

        Return SectionTable.Instance.ExportRecordData(whereFilter)
    End Function

    Public Shared Function Export(ByVal where As WhereClause) As String
        Dim whereFilter As BaseFilter = Nothing
        If Not where Is Nothing Then
            whereFilter = where.GetFilter()
        End If

        Return SectionTable.Instance.ExportRecordData(whereFilter)
    End Function

    Public Shared Function GetSum( _
        ByVal col As BaseColumn, _
        ByVal where As WhereClause, _
        ByVal orderBy As OrderBy, _
        ByVal pageIndex As Integer, _
        ByVal pageSize As Integer) _
        As String

        Dim colSel As SqlBuilderColumnSelection = New SqlBuilderColumnSelection(False, False)
        colSel.AddColumn(col, SqlBuilderColumnOperation.OperationType.Sum)

        Return SectionTable.Instance.GetColumnStatistics(colSel, Nothing, where.GetFilter(), Nothing, orderBy, pageIndex, pageSize)

    End Function

    Public Shared Function GetSum( _
        ByVal col As BaseColumn, _
        ByVal join As BaseFilter, _        
        ByVal where As WhereClause, _
        ByVal orderBy As OrderBy, _
        ByVal pageIndex As Integer, _
        ByVal pageSize As Integer) _
        As String

        Dim colSel As SqlBuilderColumnSelection = New SqlBuilderColumnSelection(False, False)
        colSel.AddColumn(col, SqlBuilderColumnOperation.OperationType.Sum)

        Return SectionTable.Instance.GetColumnStatistics(colSel, join, where.GetFilter(), Nothing, orderBy, pageIndex, pageSize)

    End Function

    
    Public Shared Function GetCount( _
        ByVal col As BaseColumn, _
        ByVal where As WhereClause, _
        ByVal orderBy As OrderBy, _
        ByVal pageIndex As Integer, _
        ByVal pageSize As Integer) _
        As String

        Dim colSel As SqlBuilderColumnSelection = New SqlBuilderColumnSelection(False, False)
        colSel.AddColumn(col, SqlBuilderColumnOperation.OperationType.Count)

        Return SectionTable.Instance.GetColumnStatistics(colSel, Nothing, where.GetFilter(), Nothing, orderBy, pageIndex, pageSize)

    End Function
    
    Public Shared Function GetCount( _
        ByVal col As BaseColumn, _
        ByVal join As BaseFilter, _         
        ByVal where As WhereClause, _
        ByVal orderBy As OrderBy, _
        ByVal pageIndex As Integer, _
        ByVal pageSize As Integer) _
        As String

        Dim colSel As SqlBuilderColumnSelection = New SqlBuilderColumnSelection(False, False)
        colSel.AddColumn(col, SqlBuilderColumnOperation.OperationType.Count)

        Return SectionTable.Instance.GetColumnStatistics(colSel, join, where.GetFilter(), Nothing, orderBy, pageIndex, pageSize)

    End Function    

    ''' <summary>
    '''  This method returns the columns in the table.
    ''' </summary>
    Public Shared Function GetColumns() As BaseColumn()
        Return SectionTable.Instance.TableDefinition.Columns
    End Function

    ''' <summary>
    '''  This method returns the columnlist in the table.
    ''' </summary>  
    Public Shared Function GetColumnList() As ColumnList
        Return SectionTable.Instance.TableDefinition.ColumnList
    End Function


    ''' <summary>
    ''' This method creates a new record and returns it to be edited.
    ''' </summary>
    Public Shared Function CreateNewRecord() As IRecord
        Return SectionTable.Instance.CreateRecord()
    End Function

    ''' <summary>
    ''' This method creates a new record and returns it to be edited.
    ''' </summary>
    ''' <param name="tempId">ID of the new record.</param>  
    Public Shared Function CreateNewRecord(ByVal tempId As String) As IRecord
        Return SectionTable.Instance.CreateRecord(tempId)
    End Function

    ''' <summary>
    ''' This method checks if column is editable.
    ''' </summary>
    ''' <param name="columnName">Name of the column to check.</param>
    Public Shared Function isReadOnlyColumn(ByVal columnName As String) As Boolean
        Dim column As BaseColumn = GetColumn(columnName)
        If (Not IsNothing(column)) Then
            Return column.IsValuesReadOnly
        Else
            Return True
        End If
    End Function

    ''' <summary>
    ''' This method gets the specified column.
    ''' </summary>
    ''' <param name="uniqueColumnName">Unique name of the column to fetch.</param>
    Public Shared Function GetColumn(ByVal uniqueColumnName As String) As BaseColumn
        Dim column As BaseColumn = SectionTable.Instance.TableDefinition.ColumnList.GetByUniqueName(uniqueColumnName)
        Return column
    End Function     

    ' Convenience method for getting a record using a string-based record identifier
    Public Shared Function GetRecord(ByVal id As String, ByVal bMutable As Boolean) As SectionRecord
        Return CType(SectionTable.Instance.GetRecordData(id, bMutable), SectionRecord)
    End Function

    ' Convenience method for getting a record using a KeyValue record identifier
    Public Shared Function GetRecord(ByVal id As KeyValue, ByVal bMutable As Boolean) As SectionRecord
        Return CType(SectionTable.Instance.GetRecordData(id, bMutable), SectionRecord)
    End Function

    ' Convenience method for creating a record
    Public Overloads Function NewRecord( _
        ByVal SectionIdValue As String, _
        ByVal SectionNameValue As String, _
        ByVal SectionAbbvrNameValue As String, _
        ByVal SectionENameValue As String, _
        ByVal MarshallFullValue As String, _
        ByVal MarShallValue As String, _
        ByVal GeneralFullValue As String, _
        ByVal GeneralValue As String, _
        ByVal LtGeneralFullValue As String, _
        ByVal LtGeneralValue As String, _
        ByVal MjGeneralFullValue As String, _
        ByVal MjGeneralValue As String, _
        ByVal SpColonelFullValue As String, _
        ByVal SpColonelValue As String, _
        ByVal ColonelFullValue As String, _
        ByVal ColonelValue As String, _
        ByVal LtColonelFullValue As String, _
        ByVal LtColonelValue As String, _
        ByVal MajorFullValue As String, _
        ByVal MajorValue As String, _
        ByVal CaptianFullValue As String, _
        ByVal CaptianValue As String, _
        ByVal LieutenantFullValue As String, _
        ByVal LieutenantValue As String, _
        ByVal SubLieutenantFullValue As String, _
        ByVal SubLieutenantValue As String, _
        ByVal Sm0FullValue As String, _
        ByVal Sm0Value As String, _
        ByVal Sm1FullValue As String, _
        ByVal Sm1Value As String, _
        ByVal Sm2FullValue As String, _
        ByVal Sm2Value As String, _
        ByVal Sm3FullValue As String, _
        ByVal Sm3Value As String, _
        ByVal SgtFullValue As String, _
        ByVal SgtValue As String, _
        ByVal CptFullValue As String, _
        ByVal CptValue As String, _
        ByVal PtcFullValue As String, _
        ByVal PtcValue As String, _
        ByVal PvtVolFullValue As String, _
        ByVal PvtVolValue As String, _
        ByVal Sm4FullValue As String, _
        ByVal Sm4Value As String, _
        ByVal PvtFullValue As String, _
        ByVal PvtValue As String, _
        ByVal Sm4NowValue As String, _
        ByVal PvtstValue As String, _
        ByVal PvtndValue As String, _
        ByVal EmpFullValue As String, _
        ByVal EmpValue As String, _
        ByVal EmpOffFullValue As String, _
        ByVal EmpOffValue As String, _
        ByVal EmpTmpFullValue As String, _
        ByVal EmpTmpValue As String _
    ) As KeyValue
        Dim rec As IPrimaryKeyRecord = CType(Me.CreateRecord(), IPrimaryKeyRecord)
                rec.SetString(SectionIdValue, SectionIdColumn)
        rec.SetString(SectionNameValue, SectionNameColumn)
        rec.SetString(SectionAbbvrNameValue, SectionAbbvrNameColumn)
        rec.SetString(SectionENameValue, SectionENameColumn)
        rec.SetString(MarshallFullValue, MarshallFullColumn)
        rec.SetString(MarShallValue, MarShallColumn)
        rec.SetString(GeneralFullValue, GeneralFullColumn)
        rec.SetString(GeneralValue, GeneralColumn)
        rec.SetString(LtGeneralFullValue, LtGeneralFullColumn)
        rec.SetString(LtGeneralValue, LtGeneralColumn)
        rec.SetString(MjGeneralFullValue, MjGeneralFullColumn)
        rec.SetString(MjGeneralValue, MjGeneralColumn)
        rec.SetString(SpColonelFullValue, SpColonelFullColumn)
        rec.SetString(SpColonelValue, SpColonelColumn)
        rec.SetString(ColonelFullValue, ColonelFullColumn)
        rec.SetString(ColonelValue, ColonelColumn)
        rec.SetString(LtColonelFullValue, LtColonelFullColumn)
        rec.SetString(LtColonelValue, LtColonelColumn)
        rec.SetString(MajorFullValue, MajorFullColumn)
        rec.SetString(MajorValue, MajorColumn)
        rec.SetString(CaptianFullValue, CaptianFullColumn)
        rec.SetString(CaptianValue, CaptianColumn)
        rec.SetString(LieutenantFullValue, LieutenantFullColumn)
        rec.SetString(LieutenantValue, LieutenantColumn)
        rec.SetString(SubLieutenantFullValue, SubLieutenantFullColumn)
        rec.SetString(SubLieutenantValue, SubLieutenantColumn)
        rec.SetString(Sm0FullValue, Sm0FullColumn)
        rec.SetString(Sm0Value, Sm0Column)
        rec.SetString(Sm1FullValue, Sm1FullColumn)
        rec.SetString(Sm1Value, Sm1Column)
        rec.SetString(Sm2FullValue, Sm2FullColumn)
        rec.SetString(Sm2Value, Sm2Column)
        rec.SetString(Sm3FullValue, Sm3FullColumn)
        rec.SetString(Sm3Value, Sm3Column)
        rec.SetString(SgtFullValue, SgtFullColumn)
        rec.SetString(SgtValue, SgtColumn)
        rec.SetString(CptFullValue, CptFullColumn)
        rec.SetString(CptValue, CptColumn)
        rec.SetString(PtcFullValue, PtcFullColumn)
        rec.SetString(PtcValue, PtcColumn)
        rec.SetString(PvtVolFullValue, PvtVolFullColumn)
        rec.SetString(PvtVolValue, PvtVolColumn)
        rec.SetString(Sm4FullValue, Sm4FullColumn)
        rec.SetString(Sm4Value, Sm4Column)
        rec.SetString(PvtFullValue, PvtFullColumn)
        rec.SetString(PvtValue, PvtColumn)
        rec.SetString(Sm4NowValue, Sm4NowColumn)
        rec.SetString(PvtstValue, PvtstColumn)
        rec.SetString(PvtndValue, PvtndColumn)
        rec.SetString(EmpFullValue, EmpFullColumn)
        rec.SetString(EmpValue, EmpColumn)
        rec.SetString(EmpOffFullValue, EmpOffFullColumn)
        rec.SetString(EmpOffValue, EmpOffColumn)
        rec.SetString(EmpTmpFullValue, EmpTmpFullColumn)
        rec.SetString(EmpTmpValue, EmpTmpColumn)


        rec.Create() 'update the DB so any DB-initialized fields (like autoincrement IDs) can be initialized

        Dim key As KeyValue = rec.GetID()
        Return key
    End Function

    ''' <summary>
    '''  This method deletes a specified record
    ''' </summary>
    ''' <param name="kv">Keyvalue of the record to be deleted.</param>
    Public Shared Sub DeleteRecord(ByVal kv As KeyValue)
        SectionTable.Instance.DeleteOneRecord(kv)
    End Sub

    ''' <summary>
    ''' This method checks if record exist in the database using the keyvalue provided.
    ''' </summary>
    ''' <param name="kv">Key value of the record.</param>
    Public Shared Function DoesRecordExist(ByVal kv As KeyValue) As Boolean
        Dim recordExist As Boolean = True
        Try
            SectionTable.GetRecord(kv, False)
        Catch ex As Exception
            recordExist = False
        End Try
        Return recordExist
    End Function
    
    ''' <summary>
    '''  This method returns all the primary columns in the table.
    ''' </summary>
    Public Shared Function GetPrimaryKeyColumns() As ColumnList
        If (Not IsNothing(SectionTable.Instance.TableDefinition.PrimaryKey)) Then
            Return SectionTable.Instance.TableDefinition.PrimaryKey.Columns
        Else
            Return Nothing
        End If
    End Function

    ''' <summary>
    ''' This method takes a key and returns a keyvalue.
    ''' </summary>
    ''' <param name="key">key could be array of primary key values in case of composite primary key or a string containing single primary key value in case of non-composite primary key.</param>
    Public Shared Function GetKeyValue(ByVal key As Object) As KeyValue
        Dim kv As KeyValue = Nothing

        If (Not (IsNothing(SectionTable.Instance.TableDefinition.PrimaryKey))) Then

            Dim isCompositePrimaryKey As Boolean = False
            isCompositePrimaryKey = SectionTable.Instance.TableDefinition.PrimaryKey.IsCompositeKey

            If ((isCompositePrimaryKey) AndAlso (key.GetType.IsArray())) Then

                ' If the key is composite, then construct a key value.
                kv = New KeyValue
                Dim fullKeyString As String = ""
                Dim keyArray As Array = CType(key, Array)
                If (Not IsNothing(keyArray)) Then
                    Dim length As Integer = keyArray.Length
                    Dim pkColumns As ColumnList = SectionTable.Instance.TableDefinition.PrimaryKey.Columns
                    Dim pkColumn As BaseColumn
                    Dim index As Integer = 0
                    For Each pkColumn In pkColumns
                        Dim keyString As String = CType(keyArray.GetValue(index), String)
                        If (SectionTable.Instance.TableDefinition.TableType = BaseClasses.Data.TableDefinition.TableTypes.Virtual) Then
                            kv.AddElement(pkColumn.UniqueName, keyString)
                        Else
                            kv.AddElement(pkColumn.InternalName, keyString)
                        End If
                        index = index + 1
                    Next pkColumn
                End If

            Else
                ' If the key is not composite, then get the key value.
                kv = SectionTable.Instance.TableDefinition.PrimaryKey.ParseValue(CType(key, String))
            End If
        End If
        Return kv
    End Function    


	 ''' <summary>
     ''' This method takes a record and a Column and returns an evaluated value of DFKA formula.
     ''' </summary>
	Public Shared Function GetDFKA(ByVal rec As BaseRecord, ByVal col As BaseColumn) As String
	    Dim fkColumn As ForeignKey = SectionTable.Instance.TableDefinition.GetExpandableNonCompositeForeignKey(col)
	    If fkColumn Is Nothing Then
 			Return Nothing
		End If
        Dim _DFKA As String = fkColumn.PrimaryKeyDisplayColumns
        If (_DFKA.Trim().StartsWith("=")) Then
            ' if the formula is in the format of "= <Primary table>.<Field name>, then pull out the data from the rec object instead of doing formula evaluation 
            Dim tableCodeName As String = fkColumn.PrimaryKeyTableDefinition.TableCodeName
            Dim column As String = _DFKA.Trim("="c).Trim()
            If column.StartsWith(tableCodeName & ".", StringComparison.InvariantCultureIgnoreCase) Then
                column = column.Substring(tableCodeName.Length + 1)
            End If

            For Each c As BaseColumn In fkColumn.PrimaryKeyTableDefinition.Columns
                If column = c.CodeName Then
                    Return rec.Format(c)
                End If
            Next        
			Dim tableName As String = fkColumn.PrimaryKeyTableDefinition.TableCodeName
			Return EvaluateFormula(_DFKA, rec, Nothing, tableName)
		Else
            Return Nothing
        End If
    End Function

	''' <summary>
    ''' This method takes a keyValue and a Column and returns an evaluated value of DFKA formula.
    ''' </summary>
	Public Shared Function GetDFKA(ByVal keyValue As String, ByVal col As BaseColumn, ByVal formatPattern as String) As String
	    If keyValue Is Nothing Then
 			Return Nothing
		End If
	    Dim fkColumn As ForeignKey = SectionTable.Instance.TableDefinition.GetExpandableNonCompositeForeignKey(col)
	    If fkColumn Is Nothing Then
 			Return Nothing
		End If
        Dim _DFKA As String = fkColumn.PrimaryKeyDisplayColumns
        If (_DFKA.Trim().StartsWith("=")) Then
			Dim tableName As String = fkColumn.PrimaryKeyTableDefinition.TableCodeName
			Dim t As PrimaryKeyTable = CType(DatabaseObjects.GetTableObject(tableName), PrimaryKeyTable)
			Dim rec As BaseRecord = Nothing
			If Not t Is Nothing Then
				Try
					rec = CType(t.GetRecordData(keyValue, False), BaseRecord)
				Catch 
					rec = Nothing
				End Try
			End If
			If rec Is Nothing Then
				Return ""
			End If
			
            ' if the formula is in the format of "= <Primary table>.<Field name>, then pull out the data from the rec object instead of doing formula evaluation 
            Dim tableCodeName As String = fkColumn.PrimaryKeyTableDefinition.TableCodeName
            Dim column As String = _DFKA.Trim("="c).Trim()
            If column.StartsWith(tableCodeName & ".", StringComparison.InvariantCultureIgnoreCase) Then
                column = column.Substring(tableCodeName.Length + 1)
            End If

            For Each c As BaseColumn In fkColumn.PrimaryKeyTableDefinition.Columns
                If column = c.CodeName Then
                    Return rec.Format(c)
                End If
            Next			
			Return EvaluateFormula(_DFKA, rec, Nothing, tableName)
		Else
            Return Nothing
        End If
    End Function

	''' <summary>
    ''' Evaluates the formula
    ''' </summary>
	Public Shared Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing, Optional ByVal name As String = "") As String
		Dim e As BaseFormulaEvaluator = New BaseFormulaEvaluator()
		If Not dataSourceForEvaluate Is Nothing Then
			e.Evaluator.Variables.Add(name, dataSourceForEvaluate)
        end if
        e.DataSource = dataSourceForEvaluate

        Dim resultObj As Object = e.Evaluate(formula)
        If resultObj Is Nothing Then
	        Return ""
        End If
        If Not String.IsNullOrEmpty(format) Then
            Return BaseFormulaUtils.Format(resultObj, format)
        Else
            Return resultObj.ToString()
        End If
    End Function


#End Region 

End Class
End Namespace
